export interface Action<T = any> {
    type: T;
}
export interface AnyAction extends Action {
    [extraProps: string]: any;
}
export declare type Reducer<S = any, A extends Action = AnyAction> = (state: S | undefined, action: A) => S;
export declare type FSA = {
    type: string;
    payload?: any;
    error?: boolean | null | undefined;
    meta?: any;
};
export declare type optimisticState = {
    optimism: {
        realisticState: any;
        actionsUntilNow: Array<string>;
        optimisms: {
            [id: string]: optimism;
        };
        actions: {
            [id: string]: FSA;
        };
    };
    [key: string]: any;
};
export declare type optimism = {
    previousActions: Array<string>;
    subsequentActions: Array<string>;
};
export declare enum optimisticActions {
    init = "INIT_OPTIMISM",
    commit = "COMMIT_OPTIMISM",
    rollback = "ROLLBACK_OPTIMISM",
    cleanup = "CLEANUP_OPTIMISM"
}
export declare function isOptimistic(action: FSA): boolean;
